/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* $Source: src/usr/cxxtest/TestSuite.C $                                 */
/*                                                                        */
/* OpenPOWER HostBoot Project                                             */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 2011,2014              */
/*                                                                        */
/* Licensed under the Apache License, Version 2.0 (the "License");        */
/* you may not use this file except in compliance with the License.       */
/* You may obtain a copy of the License at                                */
/*                                                                        */
/*     http://www.apache.org/licenses/LICENSE-2.0                         */
/*                                                                        */
/* Unless required by applicable law or agreed to in writing, software    */
/* distributed under the License is distributed on an "AS IS" BASIS,      */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or        */
/* implied. See the License for the specific language governing           */
/* permissions and limitations under the License.                         */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */

// Imported from FSP tree - /src/test/cxxtest/cxxtest/

#ifndef __cxxtest__TestSuite_cpp__
#define __cxxtest__TestSuite_cpp__

#include <limits.h>
#include <stdarg.h>
#include <arch/ppc.H>

#include <cxxtest/TestSuite.H>

trace_desc_t *g_trac_test = NULL;
TRAC_INIT(&g_trac_test, "UNIT_TEST", 4*KILOBYTE);

namespace CxxTest
{
/******************************************************************************/
// Globals/Constants
/******************************************************************************/

//
// TestSuite members
//
TestSuite::~TestSuite() {}
void TestSuite::setUp() {}
void TestSuite::tearDown() {}

/**
 *
 *   @brief Implement trace action in unit tests
 *
 *   @return void
 *
 */
void doTrace( )
{

    __sync_add_and_fetch( &g_TraceCalls, 1 );

}

/**
 *
 *   @brief Implement warn action in unit tests
 *
 *   @param [in] pointer to filename  (not used right now )
 *   @param [in] line number
 *   @param [in] warning message
 *
 *   @return void
 *
 */
void doWarn( )
{

    __sync_add_and_fetch( &g_Warnings, 1 );

}

/**
 *   @brief Implement Fail action in unit tests
 *
 *   @return none
 */

void doFailTest( )
{

    __sync_add_and_fetch( &g_FailedTests, 1 );

}

/**
 *   @brief Implement Fail action in unit tests
 *
 *   @param [in] pointer to filename  (not used right now )
 *   @param [in] line number
 *
 *   @return none
 */

void doFailTest( const char *filename, uint32_t linenum )
{
    TRACDCOMP( g_trac_test,
            "!!!       > Test %s Failed at line %d ",
            filename,
            linenum );
    __sync_add_and_fetch( &g_FailedTests, 1 );

}
/**
 *  @brief Report total number of unit tests in a test suite
 *
 *  A unit test suite will call this to report how many tests
 *  it has.  The call itself is autogenerated
 *
 *  @param [in] pointer to filename  (not used right now )
 *  @param [in] line number
 *  @param [in] trace message
 *
 *  @return void
 *
 *  @TODO do nothing with the suite name for now, later it may be useful
 *
 */
void reportTotalTests(  const char *suitename,
                        uint64_t numtests )
{

    __sync_add_and_fetch( &g_TotalTests, numtests );
    TRACDCOMP( g_trac_test,
            "Suite %s Completed ",
            suitename  );
    return;
}


};

#endif // __cxxtest__TestSuite_cpp__
